unit KeyBoard;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  IniFiles, CommCtrl, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls;

const
  FORM_WIDTH_SET    = 900;
  FORM_HEIGHT_SET   = 460;

type
  TFormKeyBoard = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    ButtonDiffToFile: TButton;
    ButtonButtonLoadFromFile: TButton;
    ButtonShowDiff: TButton;
    ButtonShowAll: TButton;
    ButtonClear: TButton;
    ButtonInitMemo: TButton;
    ButtonInitAnnsFM: TButton;
    Label1: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ListView1: TListView;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox3KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox4KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox5KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonDiffToFileClick(Sender: TObject);
    procedure ButtonButtonLoadFromFileClick(Sender: TObject);
    procedure ButtonShowDiffClick(Sender: TObject);
    procedure ButtonShowAllClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonInitMemoClick(Sender: TObject);
    procedure ButtonInitAnnsFMClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);

    procedure ChangePresentKey(Sender: TObject);
    procedure SetPresentKey(Sender: TObject);
    procedure SetCategory(Number: String; ComboBox: TcomboBox; Sender: TObject);
    procedure SetCommand(Sender: TObject);

  private
    { Private 錾 }
    StrListKeyMap: TStringList;
    BoolSaveToFile: Boolean;
  public
    { Public 錾 }
  end;

var
  FormKeyBoard: TFormKeyBoard;

implementation

uses
  Main, KeyMap;

{$R *.dfm}

procedure TFormKeyBoard.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormKeyBoard.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormKeyBoard.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //
end;

procedure TFormKeyBoard.FormCreate(Sender: TObject);
var
  sStr3: String;
begin
  //m
  StrListKeyMap := TStringList.Create;

  //Ǎ
  sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  if FileExists(sStr3) = TRUE then
  begin
    StrListKeyMap.LoadFromFile(sStr3, TEncoding.Unicode);
  end;
  //R}h̍ڂݒ
  if StrListKeyMap.Count > 0 then
  begin
    //
    SetCategory('1001', ComboBox1, Sender);
    SetCategory('1101', ComboBox1, Sender);
    SetCategory('1201', ComboBox1, Sender);
    SetCategory('1301', ComboBox1, Sender);
    SetCategory('1401', ComboBox1, Sender);
    SetCategory('1501', ComboBox1, Sender);
    SetCategory('1601', ComboBox1, Sender);
    SetCategory('1701', ComboBox1, Sender);
    SetCategory('1801', ComboBox1, Sender);
    SetCategory('1901', ComboBox1, Sender);
  end;

  //ݒ
  ListView1.Items.Clear;
  ListView1.Columns.Add.Caption  := 'R}h';
  ListView1.Columns[0].Width := 445;
  ListView1.Columns.Add.Caption  := '݂̃L[';
  ListView1.Columns[1].Width := 295;
  ListView1.Columns.Add.Caption  := '@\';
  ListView1.Columns[2].Width :=  60;
  ListView1.Columns.Add.Caption  := '';
  ListView1.Columns[3].Width :=  10;
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.ReadOnly := TRUE;

  //ݒ
  BoolSaveToFile := FALSE;
end;

procedure TFormKeyBoard.FormDestroy(Sender: TObject);
begin
  //j
  StrListKeyMap.Free;
end;

procedure TFormKeyBoard.FormResize(Sender: TObject);
begin
  ListView1.Width  := FormKeyBoard.ClientWidth  -  45;
  ListView1.Height := FormKeyBoard.ClientHeight - 145;
end;

procedure TFormKeyBoard.FormShow(Sender: TObject);
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormKeyBoard.KeyPreview := TRUE;

  //ݒ
  ComboBox1.ItemIndex := 0;
  //f
  SetCommand(Sender);
  //ݒ
  ComboBox1.SetFocus;
end;

procedure TFormKeyBoard.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //ݾ
    ButtonCancelClick(Sender);
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormKeyBoard.ButtonOKClick(Sender: TObject);
var
  sStr3: String;
begin
  //ۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  StrListKeymap.SaveToFile(sStr3, TEncoding.Unicode);
  //
  ModalResult := mrOK;
end;

procedure TFormKeyBoard.ButtonCancelClick(Sender: TObject);
begin
  if BoolSaveToFile = TRUE then
  begin
    //I
    ModalResult := mrOk;
  end
  else
  begin
    //I
    ModalResult := mrCancel;
  end;
end;

procedure TFormKeyBoard.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox3KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox4KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox5KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

procedure TFormKeyBoard.ComboBox1Change(Sender: TObject);
begin
  //R}hݒ
  SetCommand(Sender);
end;

procedure TFormKeyBoard.ComboBox2Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.ComboBox3Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.ComboBox4Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.ComboBox5Change(Sender: TObject);
begin
  //L[f
  ChangePresentKey(Sender);
end;

procedure TFormKeyBoard.SetPresentKey(Sender: TObject);
var
 sStr1: String;
 sStr2: String;
 sStr3: String;
 sStr4: String;
 sStr5: String;
 sStr6: String;
 iPos2: Integer;
 iPos3: Integer;
 iPos4: Integer;
 iRow1: Integer;
begin
  //
  if ListView1.ItemIndex = -1 then
  begin
    ListView1.ItemIndex := 0;
  end;

  //擾
  sStr1 := ListView1.Items[ListView1.ItemIndex].SubItems[0];
  iPos2 := Pos('Shift', sStr1);
  iPos3 := Pos('Ctrl',  sStr1);
  iPos4 := Pos('Alt',   sStr1);
  sStr2 := StringReplace(sStr1, 'Shift', '', [rfReplaceAll]);
  sStr3 := StringReplace(sStr2, 'Ctrl',  '', [rfReplaceAll]);
  sStr4 := StringReplace(sStr3, 'Alt',   '', [rfReplaceAll]);
  sStr5 := StringReplace(sStr4, '+',     '', [rfReplaceAll]);
  sStr6 := Trim(sStr5);

  //f
  if iPos2 = 0 then
  begin
    ComboBox2.ItemIndex := 0;
  end
  else
  begin
    ComboBox2.ItemIndex := 1;
  end;

  if iPos3 = 0 then
  begin
    ComboBox3.ItemIndex := 0;
  end
  else
  begin
    ComboBox3.ItemIndex := 1;
  end;

  if iPos4 = 0 then
  begin
    ComboBox4.ItemIndex := 0;
  end
  else
  begin
    ComboBox4.ItemIndex := 1;
  end;

  for iRow1 := 0 to ComboBox5.Items.Count-1 do
  begin
    if Trim(ComboBox5.Items.Strings[iRow1] )= sStr6 then
    begin
      ComboBox5.ItemIndex := iRow1;
      Break;
    end;
  end;
end;

procedure TFormKeyBoard.ChangePresentKey(Sender: TObject);
var
  sStr1: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  StrList1: TStringList;
begin
  //L[󔒂
  if Trim(ComboBox5.Text) = '' then
  begin
    //L[ȊOݒ肳Ă
    sStr1 := Trim(ComboBox2.Text) + Trim(ComboBox3.Text) + Trim(ComboBox4.Text);
    if (sStr1 <> '') then
    begin
      ShowMessage('Shift,Ctrl,Alt̃L[ݒ肳Ă܂' + #13#10 + 'L[ݒ肳Ă܂');
      Exit;
    end;
  end;

  //擾
  if Trim(ComboBox2.Text) <> '' then
  begin
    sStr1 := Trim(ComboBox2.Text);
  end;

  if Trim(ComboBox3.Text) <> '' then
  begin
    if sStr1 = '' then
    begin
      sStr1 := sStr1 + Trim(ComboBox3.Text);
    end
    else
    begin
      sStr1 := sStr1  + '+' + Trim(ComboBox3.Text);
    end;
  end;

  if Trim(ComboBox4.Text) <> '' then
  begin
    if sStr1 = '' then
    begin
      sStr1 := sStr1 + Trim(ComboBox4.Text);
    end
    else
    begin
      sStr1 := sStr1  + '+' + Trim(ComboBox4.Text);
    end;
  end;

  if Trim(ComboBox5.Text) <> '' then
  begin
    if sStr1 = '' then
    begin
      sStr1 := sStr1 + Trim(ComboBox5.Text);
    end
    else
    begin
      sStr1 := sStr1  + '+' + Trim(ComboBox5.Text);
    end;
  end;

  //
  if ListView1.ItemIndex = -1 then
  begin
    ListView1.ItemIndex := 0;
  end;

  //
  if sStr1 = '' then
  begin
  end
  else
  begin
    if sStr1 = ListView1.Items[ListView1.ItemIndex].SubItems[0] then
    begin
      ShowMessage('̐ݒł');
      Exit;
    end;
  end;

  //m
  StrList1 := TStringList.Create;

    //
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

      StrList1.Add(sStr11);
    end;


  //
  if sStr1 <> '' then
  begin
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //擾
      sStr11 := StrList1.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
      if sStr16 = sStr1 then
      begin
        ShowMessage('u' + sStr12  + 'v'+ #13#10 + 'ŊɎgpς݂ł̂Őݒł܂');
        Exit;
      end;
    end;
  end;

  //f
  if ListView1.Items.Count > 0 then
  begin
    //ݒ
    ListView1.Items.Item[ListView1.ItemIndex].SubItems[0] := sStr1;
    //
    for iRow1 := 0 to StrListKeyMap.Count-1 do
    begin
      //擾
      sStr11 := StrListKeyMap.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
      if sStr17 =  ListView1.Items.Item[ListView1.ItemIndex].SubItems[1] then
      begin
        StrListKeyMap.Strings[iRow1] :=  sStr12 + #9 + sStr14 + #9 + sStr1 + #9 + sStr17;
        Break;
      end;
    end;
  end;

  //j
  StrList1.Free;
end;

procedure TFormKeyBoard.SetCategory(Number: String; ComboBox: TcomboBox; Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
begin
  //ԍ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr17 = Number then
    begin
      ComboBox.Items.Add(sStr12);
      Break;
    end;
  end;
end;

procedure TFormKeyBoard.SetCommand(Sender: TObject);
var
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  nItem: TListItem;
begin
  //XV
  ListView1.Items.BeginUpdate;
  //NA
  ListView1.Items.Clear;
  //ԍ
  iRow2 := 0;
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001
    //ԍ
    if sStr12 = ComboBox1.Text then
    begin
      nItem := ListView1.Items.Add;
      nItem.Caption := sStr14;
      ListView1.Items.Item[iRow2].SubItems.Add(sStr16);
      ListView1.Items.Item[iRow2].SubItems.Add(sStr17);
      iRow2 := iRow2+1;
    end;
  end;
  //ݒ
  if ListView1.Items.Count > 0 then
  begin
    ListView1.ItemIndex := 0;
    ListView1.Selected := ListView1.Items[0];
    ListView1.ItemFocused := ListView1.Items[0];
  end;
  //XV
  ListView1.Items.EndUpdate;
  //ݒ
  ListView1Click(Sender);
end;


procedure TFormKeyBoard.ButtonDiffToFileClick(Sender: TObject);
var
  sStr2: String;
  sStr3: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  StrList1: TStringList;
  wRet1: Word;
begin
  //mF
  sStr2 := 'ύXt@Cɏ㏑ŕۑ܂H';
  wRet1 := MessageDlg(sStr2, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet1 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;

  //ԍ̃V[gJbgݒ
  for iRow1 := 0 to StrListKeyMap.Count-1 do
  begin
    //擾
    sStr11 := StrListKeyMap.Strings[iRow1];
    iPos11 := Pos(#9, sStr11);
    sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
    sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
    iPos12 := Pos(#9, sStr13);
    sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
    sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
    iPos13 := Pos(#9, sStr15);
    sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
    sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

    //ԍ
    for iRow2 := 0 to FormMain.StrListKeyMapOriginal.Count-1 do
    begin
      //擾
      sStr21 := FormMain.StrListKeyMapOriginal.Strings[iRow2];
      iPos21 := Pos(#9, sStr21);
      sStr22 := Copy(sStr21, 1,        iPos21-1);      //t@C
      sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
      iPos22 := Pos(#9, sStr23);
      sStr24 := Copy(sStr23, 1,        iPos22-1);      //VK쐬
      sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
      iPos23 := Pos(#9, sStr25);
      sStr26 := Copy(sStr25, 1,        iPos23-1);      //Ctrl+O
      sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//1001
      //ԍ
      if sStr17 = sStr27 then
      begin
        if sStr16 <> sStr26 then
        begin
          StrList1.Add(sStr11);
          Break;
        end
      end;
    end;

  end;

  //ۑ
  sStr3 := ExtractFilePath(ParamStr(0)) + KEYDIFF_LIST;
  StrList1.SaveToFile(sStr3, TEncoding.Unicode);

  //j
  StrList1.Free;

  //bZ[W\
  showmessage('t@Cۑ܂' + #13#10 + KEYDIFF_LIST);
end;

procedure TFormKeyBoard.ButtonInitAnnsFMClick(Sender: TObject);
var
  sStr1: String;
  sStr3: String;
  wRet3: Word;
begin
  //mF
  sStr3 := 'ݒĕۑ܂Bs܂H';
  wRet3 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet3 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //ݒ
  BoolSaveToFile := TRUE;

  //ۑ
  FormMain.InitKeyMap(0, Sender);
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  FormMain.StrListKeyMapOriginal.SaveToFile(sStr1, TEncoding.Unicode);
  //Ǎ
  StrListKeyMap.LoadFromFile(sStr1);

  //ݒ
  ComboBox1.ItemIndex := 0;
  //f
  SetCommand(Sender);
  //ݒ
  ComboBox1.SetFocus;
end;

procedure TFormKeyBoard.ButtonInitMemoClick(Sender: TObject);
var
  sStr1: String;
  sStr3: String;
  wRet3: Word;
begin
  //mF
  sStr3 := 'ݒĕۑ܂Bs܂H';
  wRet3 := MessageDlg(sStr3, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet3 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //ݒ
  BoolSaveToFile := TRUE;

  //ۑ
  FormMain.InitKeyMap(1, Sender);
  sStr1 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
  FormMain.StrListKeyMapOriginal.SaveToFile(sStr1, TEncoding.Unicode);
  //Ǎ
  StrListKeyMap.LoadFromFile(sStr1);

  //ݒ
  ComboBox1.ItemIndex := 0;
  //f
  SetCommand(Sender);
  //ݒ
  ComboBox1.SetFocus;
end;

procedure TFormKeyBoard.ButtonButtonLoadFromFileClick(Sender: TObject);
var
  StrList1: TStringList;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
  sStr16: String;
  sStr17: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr24: String;
  sStr25: String;
  sStr26: String;
  sStr27: String;
  iRow1: Integer;
  iRow2: Integer;
  iPos11: Integer;
  iPos12: Integer;
  iPos13: Integer;
  iPos21: Integer;
  iPos22: Integer;
  iPos23: Integer;
  wRet1: Word;
begin
  //mF
  sStr2 := 'ύX̃t@C𔽉fāAt@Cɕۑ܂H';
  wRet1 := MessageDlg(sStr2, mtInformation, [mbYes, mbNo ], 0);
  //s
  if wRet1 = mrYes then
  begin
    //
  end
  //~
  else
  begin
    Exit;
  end;

  //m
  StrList1 := TStringList.Create;

  //t@CǍ
  sStr3 := ExtractFilePath(ParamStr(0)) + KEYDIFF_LIST;
  if FileExists(sStr3) = TRUE then
  begin
     //Ǎ
    StrList1.LoadFromFile(sStr3, TEncoding.Unicode);

    //
    for iRow1 := 0 to StrList1.Count-1 do
    begin
      //擾
      sStr11 := StrList1.Strings[iRow1];
      iPos11 := Pos(#9, sStr11);
      sStr12 := Copy(sStr11, 1,        iPos11-1);      //t@C
      sStr13 := Copy(sStr11, iPos11+1, Length(sStr11));//ȍ~̕
      iPos12 := Pos(#9, sStr13);
      sStr14 := Copy(sStr13, 1,        iPos12-1);      //VK쐬
      sStr15 := Copy(sStr13, iPos12+1, Length(sStr13));//ȍ~̕
      iPos13 := Pos(#9, sStr15);
      sStr16 := Copy(sStr15, 1,        iPos13-1);      //Ctrl+O
      sStr17 := Copy(sStr15, iPos13+1, Length(sStr15));//1001

      //
      for iRow2 := 0 to StrListKeyMap.Count-1 do
      begin
        //擾
        sStr21 := StrListKeyMap.Strings[iRow2];
        iPos21 := Pos(#9, sStr21);
        sStr22 := Copy(sStr21, 1,        iPos21-1);      //t@C
        sStr23 := Copy(sStr21, iPos21+1, Length(sStr21));//ȍ~̕
        iPos22 := Pos(#9, sStr23);
        sStr24 := Copy(sStr23, 1,        iPos22-1);      //VK쐬
        sStr25 := Copy(sStr23, iPos22+1, Length(sStr23));//ȍ~̕
        iPos23 := Pos(#9, sStr25);
        sStr26 := Copy(sStr25, 1,        iPos23-1);      //Ctrl+O
        sStr27 := Copy(sStr25, iPos23+1, Length(sStr25));//1001
        if sStr17 = sStr27 then
        begin
          StrListKeyMap.Strings[iRow2] :=  sStr22 + #9 + sStr24 + #9 + sStr16 + #9 + sStr27;
          Break;
        end;
      end;
    end;

    //ۑ
    sStr4 := ExtractFilePath(ParamStr(0)) + KEYMAP_LIST;
    StrListKeyMap.SaveToFile(sStr4, TEncoding.Unicode);

    //ݒ
    BoolSaveToFile := TRUE;

    //bZ[W\
    showmessage('t@Cǂݍݔf܂' + #13#10 + KEYDIFF_LIST);
  end
  else
  begin
    //bZ[W\
    showmessage('t@C܂' + #13#10 + KEYDIFF_LIST);
  end;

  //j
  StrList1.Free;

  //f
  ComboBox1Change(Sender);

end;

procedure TFormKeyBoard.ButtonShowDiffClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteBool('ShowKeyMapItem', 'All',  FALSE);
  //j
  IniFile.Free;

  //
  FormKeyMap := TFormKeyMap.Create(Application);
  try
    FormKeyMap.ShowModal;
  finally
    //j
    FormKeyMap.Free;
  end;
end;

procedure TFormKeyBoard.ButtonShowAllClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //ۑ
  IniFile.WriteBool('ShowKeyMapItem', 'All',  TRUE);
  //j
  IniFile.Free;

  //
  FormKeyMap := TFormKeyMap.Create(Application);
  try
    FormKeyMap.ShowModal;
  finally
    //j
    FormKeyMap.Free;
  end;
end;

procedure TFormKeyBoard.ListView1Click(Sender: TObject);
begin
  //ݒ
  SetPresentKey(Sender);
end;

procedure TFormKeyBoard.ListView1AdvancedCustomDrawItem(
  Sender: TCustomListView; Item: TListItem; State: TCustomDrawState;
  Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
  AIndex: Integer;
  ARect: TRect;
  dwFormat: DWORD;
  iRow1: Integer;
  StrItem: String;
begin
  //tH[JX
  if ListView1.Focused = FALSE then
  begin
    //I
    if Item.Selected then
    begin
      //ݒ
      AIndex := Item.Index;
      //sRecẗ擾Dȉł
      //ListView_GetItemRect(ListView1.Handle, AIndex, ARect, LVIR_BOUNDS);
      ARect := Item.DisplayRect(drBounds);
//      OffsetRect(ARect, 3, 0);
      OffsetRect(ARect, 0, 0);
      //̗̈hׂ
      ListView1.Canvas.Brush.Color := clAqua;
      ListView1.Canvas.FillRect(ARect);
      ListView1.Canvas.Font.Color := clWindowText;

      //ݒ
      SetBkMode(ListView1.Canvas.Handle, TRANSPARENT);
      dwFormat := DT_SINGLELINE or DT_VCENTER;
      //Ō܂ŕ`
      for iRow1 := 0 to ListView1.Columns.Count-2 do
      begin
        //`ʒuݒ
        case ListView1.Column[iRow1].Alignment of
          taRightJustify: dwFormat := dwFormat or DT_RIGHT;
          taCenter      : dwFormat := dwFormat or DT_CENTER;
        else
          dwFormat := dwFormat or DT_LEFT;
        end;
        //Caption̂̏ꍇ
        if iRow1 = 0 then
        begin
          //͈͂擾
          ARect   := Item.DisplayRect(drLabel);
          //
          ARect   := Rect(ARect.Left + 3, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.Caption;
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end
        //CaptionȊO
        else
        begin
          //CommCtrlKvBdvłB
          //͈͂擾
          ListView_GetSubItemRect(ListView1.Handle, AIndex, iRow1, LVIR_LABEL, @ARect);
          //
          ARect   := Rect(ARect.Left + 6, ARect.Top, ARect.Right, ARect.Bottom);
          //\
          StrItem := Item.SubItems[iRow1-1];
          DrawText(ListView1.Canvas.Handle, PChar(StrItem), -1, ARect, dwFormat);
        end;
      end;
      //{̕`͎sȂ悤ɂȂƁAꕔ̍sŃtHgȂĂ܂
      DefaultDraw := False;
    end;
  end;

end;

procedure TFormKeyBoard.ListView1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ݒ
  SetPresentKey(Sender);
end;

procedure TFormKeyBoard.ButtonClearClick(Sender: TObject);
begin
  ComboBox2.ItemIndex := 0;
  ComboBox3.ItemIndex := 0;
  ComboBox4.ItemIndex := 0;
  ComboBox5.ItemIndex := 0;
  //L[f
  ChangePresentKey(Sender);
end;

end.

